<?php
/*
Plugin Name: Email Functionality Tester
Plugin URI: http://www.tipsandtricks-hq.com
Description: This plugin allows you to test if your WordPress installation can send email correctly. If your WordPress installation can't send emails then other plugins won't be able to send emails either.
Version: 1.1
Author: Tips and Tricks HQ
Author URI: http://www.tipsandtricks-hq.com
*/

// add the admin menu option
add_action( 'admin_menu', 'checkemail_add_admin' );
function checkemail_add_admin() {
	add_submenu_page( 'options-general.php', __("Test Email", "checkemail"), __("Test Email", "checkemail"), 'edit_users', 'checkemail', 'checkemail' );
}

// add the JavaScript
add_action( 'admin_head', 'checkemail_add_js' );
function checkemail_add_js() {
	if ( isset( $_GET["page"] ) && $_GET["page"] == "checkemail" ) {
		echo '
		<script type="text/javascript">
		jQuery(document).ready(function(){
			jQuery(".checkemail-hide").hide();
			jQuery("#checkemail_autoheaders,#checkemail_customheaders").bind("change", function(){
				if (jQuery("#checkemail_autoheaders").is(":checked")){
					jQuery("#customheaders").hide();
					jQuery("#autoheaders").show();
				}
				if (jQuery("#checkemail_customheaders").is(":checked")){
					jQuery("#autoheaders").hide();
					jQuery("#customheaders").show();
				}
			});
		});
		</script>
		';
	}
}
// add the CSS
add_action( 'admin_head', 'checkemail_add_css' );
function checkemail_add_css() {
	if ( isset( $_GET["page"] ) && $_GET["page"] == "checkemail" ) {
		echo '
		<style type="text/css">
		#checkemail label {
			width: 16em;
			float: left;
		}
		#checkemail .text {
			width: 30em;
		}
		#checkemail p, #checkemail pre {
			clear: left;
		}
		</style>
		';
	}
}

// load the check email admin page
function checkemail() {
	global $current_user;

	echo '
	<div id="checkemail" class="wrap">
	';
	
	if (isset( $_POST["checkemail_to"]) && $_POST["checkemail_to"] != "" )
	{
		$headers = checkemail_send( $_POST["checkemail_to"], $_POST["checkemail_headers"] );
		echo '<div class="updated"><p>' . __( 'The test email has been sent by WordPress. Check your inbox. Please note that this does not mean that the email was actually sent out by your server. The headers sent with this email were:', "checkemail" ) . '</p><pre>' . str_replace( chr( 10 ), '\n' . "\n", str_replace( chr( 13 ), '\r', $headers ) ) . '</pre></div>';
	}
		
	echo '<h2>' . __( "Test Email Functionality" ) . '</h2>';
	
	echo '<div style="border-bottom: 1px solid #dedede; height: 10px"></div>';
	echo '<form action="options-general.php?page=checkemail" method="post">
	<p><label for="checkemail_to">' . __( "Send test email to:", "checkemail" ) . '</label>
	<input type="text" name="checkemail_to" id="checkemail_to" class="text"';
		if ( isset( $_POST["checkemail_to"] ) ) {
			echo ' value="' . $_POST["checkemail_to"] . '"';
		}
		echo ' /> <i>Enter the recipient email address.</i></p>';

	echo '<p><label for="checkemail_subject">' . __( "Email Subject:", "checkemail" ) . '</label>
	<input type="text" name="checkemail_subject" id="checkemail_subject" class="text"';
		if ( isset( $_POST["checkemail_subject"] ) ) {
			echo ' value="' . $_POST["checkemail_subject"] . '"';
		}
		else{
			echo ' value="This is a test email subject"';
		}
		echo ' /> <i>Enter the email subject.</i></p>';
				
	echo '<p><label for="checkemail_body">' . __( "Email Body:", "checkemail" ) . '</label>
	<textarea name="checkemail_body" id="checkemail_body" cols="83" rows="7">';
		if ( isset( $_POST["checkemail_body"] ) ) {echo $_POST["checkemail_body"];}
		else {echo "Test email sent from the email tester plugin", "This test email proves that your WordPress installation can send emails.\n\nSent: " . date( "r" );}
		echo '</textarea></p>';
				
	echo '<div style="border-bottom: 1px solid #dedede; height: 10px"></div>';		
	echo '<p>You can use the standard default header or choose the custom option where you will be able to specify a from email address value.</p>';
	echo '<p><label for="checkemail_autoheaders">' . __( "Use standard headers", "checkemail" ) . '</label>
	<input type="radio" id="checkemail_autoheaders" name="checkemail_headers" value="auto"';
	if ( !isset($_POST["checkemail_headers"]) || $_POST["checkemail_headers"] == "auto" ){
		echo ' checked="checked"';
	}
	echo '	/></p>
	<pre id="autoheaders"';
	if ( isset($_POST["checkemail_headers"]) && $_POST["checkemail_headers"] == "custom" ){
		echo ' class="checkemail-hide"';
	}
	echo '>MIME-Version: 1.0
From: ' . $current_user->user_email . '
Content-Type: text/plain; charset="' . get_option( 'blog_charset' ) . '"</pre>
	<p><label for="checkemail_customheaders">' . __( "Use custom headers", "checkemail" ) . '</label>
	<input type="radio" id="checkemail_customheaders" name="checkemail_headers" value="custom"';
	if ( isset($_POST["checkemail_headers"]) && $_POST["checkemail_headers"] == "custom" ){
		echo ' checked="checked"';
	}
	echo '	/></p>
	<div id="customheaders"';
	if ( !isset($_POST["checkemail_headers"]) || $_POST["checkemail_headers"] == "auto" ){
		echo ' class="checkemail-hide"';
	}
	echo '>
		<p>' . __( "Set your custom headers below", "checkemail" ) . '</p>
		<p><label for="checkemail_mime">' . __( "MIME Version", "checkemail" ) . '</label>
		<input type="text" name="checkemail_mime" id="checkemail_mime" value="';
		if ( isset( $_POST["checkemail_mime"] ) ) {
			echo $_POST["checkemail_mime"];
		} else {
			echo '1.0';
		}
		echo '" /></p>
		<p><label for="checkemail_type">' . __( "Content type", "checkemail" ) . '</label>
		<input type="text" name="checkemail_type" id="checkemail_type" value="';
		if ( isset( $_POST["checkemail_type"] ) ) {
			echo $_POST["checkemail_type"];
		} else {
			echo 'text/html; charset=iso-8859-1';
		}
		echo '" class="text"  /></p>
		<p><label for="checkemail_from">' . __( "From", "checkemail" ) . '</label>
		<input type="text" name="checkemail_from" id="checkemail_from" value="';
		if ( isset( $_POST["checkemail_from"] ) ) {
			echo $_POST["checkemail_from"];
		} else {
			echo $current_user->user_email;
		}
		echo '" class="text"  /></p>
		<p><label for="checkemail_cc">' . __( "CC", "checkemail" ) . '</label>
		<textarea name="checkemail_cc" id="checkemail_cc" cols="30" rows="4" class="text">';
		if ( isset( $_POST["checkemail_cc"] ) ) {
			echo $_POST["checkemail_cc"];
		}
		echo '</textarea></p>
		<p><label for="checkemail_break_n">' . __( "Header line break type", "checkemail" ) . '</label>
		<input type="radio" name="checkemail_break" id="checkemail_break_n" value="\n"';
		if ( !isset( $_POST["checkemail_break"] ) || $_POST["checkemail_break"] == '\n' ) {
			echo ' checked="checked"';
		}
		echo ' /> \n
		<input type="radio" name="checkemail_break" id="checkemail_break_rn" value="\r\n"';
		if ( isset( $_POST["checkemail_break"] ) && $_POST["checkemail_break"] == '\r\n' ) {
			echo ' checked="checked"';
		}
		echo ' /> \r\n</p>
	</div>';
	echo '<div style="border-bottom: 1px solid #dedede; height: 10px"></div>';
	echo '<p><label for="checkemail_go" class="checkemail-hide">' . __( "Send", "checkemail" ) . '</label>
	<input type="submit" name="checkemail_go" id="checkemail_go" class="button-primary" value="' . __( "Send test email", "checkemail" ) . '" /></p>
	</form>
	
	</div>
	';
		
}

function checkemail_send($to, $headers = "auto") {
	global $current_user;
	if ( $headers == "auto" ) {
		$headers = "MIME-Version: 1.0\r\n" .
		"From: " . $current_user->user_email . "\r\n" .
		"Content-Type: text/plain; charset=\"" . get_option('blog_charset') . "\"\r\n";
	} else {
		$break = chr( 10 );
		if ( stripslashes( $_POST["checkemail_break"] ) == '\r\n' ) {
			$break = chr( 13 ) . chr( 10 );
		}
		$headers = "MIME-Version: " . trim( $_POST["checkemail_mime"] ) . $break .
		"From: " . trim( $_POST["checkemail_from"] ) . $break .
		"Cc: " . trim( $_POST["checkemail_cc"] ) . $break .
		"Content-Type: " . trim( $_POST["checkemail_type"] ) . $break;
	}
	$subject = $_POST["checkemail_subject"];
	$body = $_POST["checkemail_body"];
	wp_mail( $to, $subject, $body, $headers );
	return $headers;
}
